//////////////////////////////////////////////////////////////////////////////
//
// File:	black.h
// Directory:	/users/hartmann/rapid/src
//
//////////////////////////////////////////////////////////////////////////////

#ifndef BLACK_H
#define BLACK_H



#include "blind.h"

//system signals--defined in kernel.C
extern const sysig 	NOsig, Fsig, Bsig, Errsig;



//////////////////////////////////////////////////////////////////////////////
//
// STRUCT: outJunction
//
//////////////////////////////////////////////////////////////////////////////

class blackBox;

struct outJunction
{

   int 		N;
   blackBox	**To;
   int		*Port;	// negativ value of Port[i] tells 'undefined'
   signal	**Data;
   int 		*Size;
   
   outJunction(int);

};



//////////////////////////////////////////////////////////////////////////////
//
// STRUCT: inJunction
//
//////////////////////////////////////////////////////////////////////////////

struct inJunction
{

   int 		N;
   blackBox	**From;
   int		*Port;	// negativ value of Port[i] tells 'undefined'
   signal	**Data;
   int 		*Size;
   boolean	*Semafor;
   
   inJunction(int);

};



//////////////////////////////////////////////////////////////////////////////
//
// CLASS: blackBox
//
//////////////////////////////////////////////////////////////////////////////

class blackBox : public blindBox
{

   friend class kernel;
   
   protected:
      inJunction	*Xin, *Yin;
      outJunction	*Xout, *Yout;
      
      char		*Type;
      sysig		StartSig;
      
   protected:
      blackBox(char*, char*, int Xins=0, int Youts=0, int Yins=0, int Xouts=0);

      virtual sysig forward() 
	 { return NOsig; };
      virtual sysig backward() 
	 { return NOsig; };

	//
        // inherited functions should return signals:
 	//	NOsig	if neither forward nor backward processes -->
      	//	Fsig	if forward processes -->
      	//	Bsig	if backward processes -->
        //		-->	are supposed or
	//	Errsig  if error has occured
	//
	             
      virtual result init() 
	 { return OKAY; };
      virtual result save() 
	 { return OKAY; };
      virtual result shutdown()
	 { return OKAY; };

};



#endif
