//////////////////////////////////////////////////////////////////////////////
//
// File:	errtool.h  -- errors managing defines
// Directory:	/users/hartmann/rapid/src
//
// Usage: 	ErrOutput<<"some text\n";	-printing message
//		ErrNOutput(n)<<"some text\n";	-printing error 
//						 number and text
//		WarnOutput<<"some text\n";	-printing warning
//		Done;				-Done is written
//
//////////////////////////////////////////////////////////////////////////////

#ifndef ERROR_H
#define ERROR_H



#include <iostream.h>

extern char *ProgLabel;

#define ErrOutput 	cerr << ProgLabel << ":ERROR:"
#define ErrNOutput(n) 	cerr << ProgLabel << ":ERROR[" << n << "]:"
#define WarnOutput 	cerr << ProgLabel << ":Warning:"
#define WarnNOutput(n) 	cerr << ProgLabel << ":Warning[" << n << "]:"
#define Done    	cerr << ProgLabel << ":Done.\n"
#define Bug		cerr << ProgLabel << ":It looks like a bug.\n"
#define Sign		Signature << ':'

#define OKAY 	0
#define EMPTY 	1
#define FAILED 	2

#define exitus exit(FAILED)


// some often used error messages
#define MallocErr 	"Dynamic memory allocation error.\n"
#define FopenErr(fname)	"Unable to open file '" << fname << "'\n"
#define FcloseErr(fname) "Unable to close the file '" << fname << "'\n"

#endif
