///////////////////////////////////////////////////
//
// File 	:  mlp.C
// Directory    :  /users/pbienst/mlp
//
////////////////////////////////////////////////////

#include "mlp.h"
#include "mlpkrnl.h"

// subprogram keywords 
const char *IoStr    = "io";
const char *TrainStr = "train";
const char *TestStr  = "test";
const char *ConfStr  = "confusion";
const char *ClassStr = "classify";
   
char *ProgLabel="mlp";

int main(int argc, char **argv)  
{

   if ( (argc != 3) ||
        (   (strcmp(IoStr,   argv[1]))
	 && (strcmp(TrainStr,argv[1]))
	 && (strcmp(TestStr ,argv[1]))
	 && (strcmp(ConfStr, argv[1])) 
	 && (strcmp(ClassStr,argv[1]))
	 ) 
      
      )
   {
      fprintf(stderr,"Usage: %s %s <specification file>\n", argv[0], IoStr);
      fprintf(stderr,"   or  %s %s <specification file>\n", argv[0], TrainStr);
      fprintf(stderr,"   or  %s %s <specification file>\n", argv[0], TestStr);
      fprintf(stderr,"   or  %s %s <specification file>\n", argv[0], ConfStr);
      fprintf(stderr,"   or  %s %s <specification file>\n", argv[0], ClassStr);
      return 1;
   }
   
   kernel Kernel(argv[1],argv[2]);

   Kernel.init_kernel();
   Kernel.config_general();
   if (!(strcmp(IoStr,   argv[1]))) Kernel.config_io();
   if (!(strcmp(TrainStr,argv[1]))) Kernel.config_train();
   if (!(strcmp(TestStr, argv[1]))) Kernel.config_test();
   if (!(strcmp(ConfStr, argv[1]))) Kernel.config_conf();
   if (!(strcmp(ClassStr,argv[1]))) Kernel.config_class();
   Kernel.init_boxes();
   Kernel.process();
   Kernel.shutdown();
   
   return 1;

}

